VTK: vtkPointsProjectedHull Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkPointsProjectedHull Class Reference

the convex hull of the orthogonal projection of the vtkPoints in the 3 coordinate directions More...

`#include <vtkPointsProjectedHull.h>`

Inheritance diagram for vtkPointsProjectedHull:
[legend]
Collaboration diagram for vtkPointsProjectedHull:
[legend]

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPointsProjectedHull * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | RectangleIntersectionX (vtkPoints *R)
| determine whether the resulting rectangle intersects the convex hull of the projection of the points along that axis. More...
int | RectangleIntersectionX (float ymin, float ymax, float zmin, float zmax)
| the convex hull of the projection of the points along the positive X-axis. More...
int | RectangleIntersectionX (double ymin, double ymax, double zmin, double zmax)
int | RectangleIntersectionY (vtkPoints *R)
| of the parallel projection along the Y axis of the points More...
int | RectangleIntersectionY (float zmin, float zmax, float xmin, float xmax)
| the convex hull of the projection of the points along the positive Y-axis. More...
int | RectangleIntersectionY (double zmin, double zmax, double xmin, double xmax)
int | RectangleIntersectionZ (vtkPoints *R)
| of the parallel projection along the Z axis of the points More...
int | RectangleIntersectionZ (float xmin, float xmax, float ymin, float ymax)
| the convex hull of the projection of the points along the positive Z-axis. More...
int | RectangleIntersectionZ (double xmin, double xmax, double ymin, double ymax)
int | GetCCWHullX (float *pts, int len)
| Returns the coordinates (y,z) of the points in the convex hull of the projection of the points down the positive x-axis. More...
int | GetCCWHullX (double *pts, int len)
int | GetCCWHullY (float *pts, int len)
| Returns the coordinates (z, x) of the points in the convex hull of the projection of the points down the positive y-axis. More...
int | GetCCWHullY (double *pts, int len)
int | GetCCWHullZ (float *pts, int len)
| Returns the coordinates (x, y) of the points in the convex hull of the projection of the points down the positive z-axis. More...
int | GetCCWHullZ (double *pts, int len)
int | GetSizeCCWHullX ()
| Returns the number of points in the convex hull of the projection of the points down the positive x-axis. More...
int | GetSizeCCWHullY ()
| Returns the number of points in the convex hull of the projection of the points down the positive y-axis. More...
int | GetSizeCCWHullZ ()
| Returns the number of points in the convex hull of the projection of the points down the positive z-axis. More...
void | Initialize () override
| Return object to instantiated state. More...
void | Reset () override
| Make object look empty but do not delete memory. More...
void | Update ()
| Forces recalculation of convex hulls, use this if you delete/add points. More...
Public Member Functions inherited from vtkPoints
vtkPoints * | NewInstance () const
virtual vtkTypeBool | Allocate (vtkIdType sz, vtkIdType ext=1000)
| Allocate initial memory size. More...
virtual void | SetData (vtkDataArray *)
| Set/Get the underlying data array. More...
vtkDataArray * | GetData ()
virtual int | GetDataType () const
| Return the underlying data type. More...
virtual void | SetDataType (int dataType)
| Specify the underlying data type of the object. More...
void | SetDataTypeToBit ()
void | SetDataTypeToChar ()
void | SetDataTypeToUnsignedChar ()
void | SetDataTypeToShort ()
void | SetDataTypeToUnsignedShort ()
void | SetDataTypeToInt ()
void | SetDataTypeToUnsignedInt ()
void | SetDataTypeToLong ()
void | SetDataTypeToUnsignedLong ()
void | SetDataTypeToFloat ()
void | SetDataTypeToDouble ()
void * | GetVoidPointer (const int id)
| Return a void pointer. More...
virtual void | Squeeze ()
| Reclaim any extra memory. More...
unsigned long | GetActualMemorySize ()
| Return the memory in kibibytes (1024 bytes) consumed by this attribute data. More...
vtkIdType | GetNumberOfPoints () const
| Return number of points in array. More...
double * | GetPoint (vtkIdType id)
| Return a pointer to a double point x[3] for a specific id. More...
void | GetPoint (vtkIdType id, double x[3])
| Copy point components into user provided array v[3] for specified id. More...
void | SetPoint (vtkIdType id, const float x[3])
| Insert point into object. More...
void | SetPoint (vtkIdType id, const double x[3])
void | SetPoint (vtkIdType id, double x, double y, double z)
void | InsertPoints (vtkIdList *dstIds, vtkIdList *srcIds, vtkPoints *source)
| Copy the points indexed in srcIds from the source array to the tuple locations indexed by dstIds in this array. More...
void | InsertPoints (vtkIdType dstStart, vtkIdType n, vtkIdType srcStart, vtkPoints *source)
| Copy n consecutive points starting at srcStart from the source array to this array, starting at the dstStart location. More...
vtkIdType | InsertNextPoint (const float x[3])
| Insert point into next available slot. More...
vtkIdType | InsertNextPoint (const double x[3])
vtkIdType | InsertNextPoint (double x, double y, double z)
void | SetNumberOfPoints (vtkIdType numPoints)
| Specify the number of points for this object to hold. More...
vtkTypeBool | Resize (vtkIdType numPoints)
| Resize the internal array while conserving the data. More...
void | GetPoints (vtkIdList *ptId, vtkPoints *outPoints)
| Given a list of pt ids, return an array of points. More...
virtual void | ComputeBounds ()
| Determine (xmin,xmax, ymin,ymax, zmin,zmax) bounds of points. More...
double * | GetBounds ()
| Return the bounds of the points. More...
void | GetBounds (double bounds[6])
| Return the bounds of the points. More...
vtkMTimeType | GetMTime () override
| The modified time of the points. More...
void | Modified () override
| Update the modification time for this object and its Data. More...
virtual void | DeepCopy (vtkPoints *ad)
| Different ways to copy data. More...
virtual void | ShallowCopy (vtkPoints *ad)
| Different ways to copy data. More...
void | InsertPoint (vtkIdType id, const float x[3])
| Insert point into object. More...
void | InsertPoint (vtkIdType id, const double x[3])
| Insert point into object. More...
void | InsertPoint (vtkIdType id, double x, double y, double z)
| Insert point into object. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPointsProjectedHull * | SafeDownCast (vtkObjectBase *o)
static vtkPointsProjectedHull * | New ()
Static Public Member Functions inherited from vtkPoints
static vtkPoints * | New (int dataType)
static vtkPoints * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPoints * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPointsProjectedHull ()
| ~vtkPointsProjectedHull () override
Protected Member Functions inherited from vtkPoints
| vtkPoints (int dataType=VTK_FLOAT)
| ~vtkPoints () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Public Types inherited from vtkPoints
typedef vtkObject | Superclass
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkPoints
double | Bounds [6]
vtkTimeStamp | ComputeTime
vtkDataArray * | Data
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

the convex hull of the orthogonal projection of the vtkPoints in the 3 coordinate directions

a subclass of vtkPoints, it maintains the counter clockwise convex hull of the points (projected orthogonally in the three coordinate directions) and has a method to test for intersection of that hull with an axis aligned rectangle. This is used for intersection tests of 3D volumes.

Online Examples:

Definition at line 33 of file vtkPointsProjectedHull.h.

## Constructor & Destructor Documentation

## ◆ vtkPointsProjectedHull()

vtkPointsProjectedHull::vtkPointsProjectedHull | ( |  | ) |
| protected

## ◆ ~vtkPointsProjectedHull()

vtkPointsProjectedHull::~vtkPointsProjectedHull | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkPointsProjectedHull::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPointsProjectedHull::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkPoints.

## ◆ SafeDownCast()

static vtkPointsProjectedHull* vtkPointsProjectedHull::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPointsProjectedHull::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkPoints.

## ◆ NewInstance()

vtkPointsProjectedHull* vtkPointsProjectedHull::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPointsProjectedHull::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkPoints.

## ◆ New()

static vtkPointsProjectedHull* vtkPointsProjectedHull::New | ( |  | ) |
| static

## ◆ RectangleIntersectionX() [1/3]

int vtkPointsProjectedHull::RectangleIntersectionX | ( | vtkPoints * | R | ) |

determine whether the resulting rectangle intersects the convex hull of the projection of the points along that axis.

## ◆ RectangleIntersectionX() [2/3]

int vtkPointsProjectedHull::RectangleIntersectionX | ( | float | ymin,
|  | float | ymax,
|  | float | zmin,
|  | float | zmax
| ) |  |

the convex hull of the projection of the points along the positive X-axis.

## ◆ RectangleIntersectionX() [3/3]

int vtkPointsProjectedHull::RectangleIntersectionX | ( | double | ymin,
|  | double | ymax,
|  | double | zmin,
|  | double | zmax
| ) |  |

## ◆ RectangleIntersectionY() [1/3]

int vtkPointsProjectedHull::RectangleIntersectionY | ( | vtkPoints * | R | ) |

of the parallel projection along the Y axis of the points

## ◆ RectangleIntersectionY() [2/3]

int vtkPointsProjectedHull::RectangleIntersectionY | ( | float | zmin,
|  | float | zmax,
|  | float | xmin,
|  | float | xmax
| ) |  |

the convex hull of the projection of the points along the positive Y-axis.

## ◆ RectangleIntersectionY() [3/3]

int vtkPointsProjectedHull::RectangleIntersectionY | ( | double | zmin,
|  | double | zmax,
|  | double | xmin,
|  | double | xmax
| ) |  |

## ◆ RectangleIntersectionZ() [1/3]

int vtkPointsProjectedHull::RectangleIntersectionZ | ( | vtkPoints * | R | ) |

of the parallel projection along the Z axis of the points

## ◆ RectangleIntersectionZ() [2/3]

int vtkPointsProjectedHull::RectangleIntersectionZ | ( | float | xmin,
|  | float | xmax,
|  | float | ymin,
|  | float | ymax
| ) |  |

the convex hull of the projection of the points along the positive Z-axis.

## ◆ RectangleIntersectionZ() [3/3]

int vtkPointsProjectedHull::RectangleIntersectionZ | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax
| ) |  |

## ◆ GetCCWHullX() [1/2]

int vtkPointsProjectedHull::GetCCWHullX | ( | float * | pts,
|  | int | len
| ) |  |

Returns the coordinates (y,z) of the points in the convex hull of the projection of the points down the positive x-axis.

pts has storage for len*2 values.

## ◆ GetCCWHullX() [2/2]

int vtkPointsProjectedHull::GetCCWHullX | ( | double * | pts,
|  | int | len
| ) |  |

## ◆ GetCCWHullY() [1/2]

int vtkPointsProjectedHull::GetCCWHullY | ( | float * | pts,
|  | int | len
| ) |  |

Returns the coordinates (z, x) of the points in the convex hull of the projection of the points down the positive y-axis.

pts has storage for len*2 values.

## ◆ GetCCWHullY() [2/2]

int vtkPointsProjectedHull::GetCCWHullY | ( | double * | pts,
|  | int | len
| ) |  |

## ◆ GetCCWHullZ() [1/2]

int vtkPointsProjectedHull::GetCCWHullZ | ( | float * | pts,
|  | int | len
| ) |  |

Returns the coordinates (x, y) of the points in the convex hull of the projection of the points down the positive z-axis.

pts has storage for len*2 values.

## ◆ GetCCWHullZ() [2/2]

int vtkPointsProjectedHull::GetCCWHullZ | ( | double * | pts,
|  | int | len
| ) |  |

## ◆ GetSizeCCWHullX()

int vtkPointsProjectedHull::GetSizeCCWHullX | ( |  | ) |

Returns the number of points in the convex hull of the projection of the points down the positive x-axis.

## ◆ GetSizeCCWHullY()

int vtkPointsProjectedHull::GetSizeCCWHullY | ( |  | ) |

Returns the number of points in the convex hull of the projection of the points down the positive y-axis.

## ◆ GetSizeCCWHullZ()

int vtkPointsProjectedHull::GetSizeCCWHullZ | ( |  | ) |

Returns the number of points in the convex hull of the projection of the points down the positive z-axis.

## ◆ Initialize()

void vtkPointsProjectedHull::Initialize | ( |  | ) |
| overridevirtual

Return object to instantiated state.

Reimplemented from vtkPoints.

## ◆ Reset()

void vtkPointsProjectedHull::Reset | ( |  | ) |
| inlineoverridevirtual

Make object look empty but do not delete memory.

Reimplemented from vtkPoints.

Definition at line 134 of file vtkPointsProjectedHull.h.

## ◆ Update()

void vtkPointsProjectedHull::Update | ( |  | ) |

Forces recalculation of convex hulls, use this if you delete/add points.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkPointsProjectedHull.h